package com.sun.xml.internal.ws.api;

import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import com.oracle.webservices.internal.api.message.BasePropertySet;

public abstract class PropertySet extends BasePropertySet
{
    public PropertySet() {
    }
    
    @Deprecated
    protected static PropertySet.PropertyMap parse(Class clazz) {
        BasePropertySet.PropertyMap pm = BasePropertySet.parse(clazz);
        PropertySet.PropertyMap map = new PropertySet.PropertyMap();
        map.putAll(pm);
        return map;
    }
    
    public Object get(Object key) {
        BasePropertySet.Accessor sp = (BasePropertySet.Accessor)this.getPropertyMap().get(key);
        if (sp != null) {
            return sp.get(this);
        }
        throw new IllegalArgumentException("Undefined property " + key);
    }
    
    public Object put(String key, Object value) {
        BasePropertySet.Accessor sp = (BasePropertySet.Accessor)this.getPropertyMap().get(key);
        if (sp != null) {
            Object old = sp.get(this);
            sp.set(this, value);
            return old;
        }
        throw new IllegalArgumentException("Undefined property " + key);
    }
    
    public boolean supports(Object key) {
        return this.getPropertyMap().containsKey(key);
    }
    
    public Object remove(Object key) {
        BasePropertySet.Accessor sp = (BasePropertySet.Accessor)this.getPropertyMap().get(key);
        if (sp != null) {
            Object old = sp.get(this);
            sp.set(this, null);
            return old;
        }
        throw new IllegalArgumentException("Undefined property " + key);
    }
    
    protected void createEntrySet(Set<Map.Entry<String, Object>> core) {
        for (Map.Entry<String, BasePropertySet.Accessor> e : this.getPropertyMap().entrySet()) {
            core.add(new Map.Entry<String, Object>() {
                @Override
                public String getKey() {
                    return (String)e.getKey();
                }
                
                @Override
                public Object getValue() {
                    return ((BasePropertySet.Accessor)e.getValue()).get(PropertySet.this);
                }
                
                @Override
                public Object setValue(Object value) {
                    BasePropertySet.Accessor acc = (BasePropertySet.Accessor)e.getValue();
                    Object old = acc.get(PropertySet.this);
                    acc.set(PropertySet.this, value);
                    return old;
                }
            });
        }
    }
    
    protected abstract PropertySet.PropertyMap getPropertyMap();
    
    protected static class PropertyMap extends BasePropertySet.PropertyMap
    {
    }
}
